#ifndef _VERTEX_H_
#define _VERTEX_H_

#include "HalfEdge.h"
#include "Point.h"

class Vertex
{
public:		
	Vertex()
	{ 
		m_halfedge = NULL; 
	}
	~Vertex(){;}

	Point & point() { return  m_point; }
	HalfEdge * & halfedge(){ return m_halfedge; }

	int & id() { return m_id; }		
	bool & boundary() { return m_boundary; }	//whether this is a boundary vertex

	std::string & PropertyStr() { return m_propertyStr;}
	
	HalfEdge *  most_ccw_in_halfedge();
	HalfEdge *  most_ccw_out_halfedge();
	HalfEdge *  most_clw_in_halfedge();
	HalfEdge *  most_clw_out_halfedge();

protected:
	//for half-edge data structure
	Point			m_point;
	HalfEdge	*	m_halfedge;

	//additionally
	int				m_id;		
	bool			m_boundary; //whether this is a boundary vertex
	std::string		m_propertyStr;
};

#endif
